// Fill out your copyright notice in the Description page of Project Settings.


#include "VisionLinkEnemyLOSTest.h"

#include "Components/BoxComponent.h"
#include "Kismet/KismetMathLibrary.h"

// Sets default values
AVisionLinkEnemyLOSTest::AVisionLinkEnemyLOSTest()
{
 	// Set this actor to call Tick() every frame.  You can turn this off to improve performance if you don't need it.
	PrimaryActorTick.bCanEverTick = true;

}

// Called when the game starts or when spawned
void AVisionLinkEnemyLOSTest::BeginPlay()
{
	Super::BeginPlay();
	
}

// Called every frame
void AVisionLinkEnemyLOSTest::Tick(float DeltaTime)
{
	Super::Tick(DeltaTime);

}

void AVisionLinkEnemyLOSTest::TestLOS(TArray<FString> EnemiesInLink, AActor* LOSActor)
{
	// Get all overlapping Actors
	UBoxComponent* CollisionBox = Cast<UBoxComponent>(GetComponentByClass(UBoxComponent::StaticClass()));
	if (!IsValid(CollisionBox))
	{
		Destroy();
		return;
	}
	TArray<AActor*> OverlappingEnemies;
	CollisionBox->GetOverlappingActors(OverlappingEnemies);
	if (OverlappingEnemies.IsEmpty())
	{
		Destroy();
		return;
	}

	for (int i = 0; i < OverlappingEnemies.Num(); i++)
	{
		UE_LOG(LogTemp, Warning, TEXT("Overlapping Enemy Name: %s"), *OverlappingEnemies[i]->GetName());
		// Overlapping Enemies Array should only contain enemies which aren't already in the link
		if (!OverlappingEnemies[i]->ActorHasTag(FName("Enemy")) || EnemiesInLink.Contains(OverlappingEnemies[i]->GetName())) OverlappingEnemies.RemoveAt(i);
	}
	if (OverlappingEnemies.IsEmpty())
	{
		Destroy();
		return;
	}

	for (AActor* Enemy : OverlappingEnemies)
	{
		FRotator LookAtRotation = UKismetMathLibrary::FindLookAtRotation(LOSActor->GetActorLocation(), Enemy->GetActorLocation());
		UE_LOG(LogTemp, Warning, TEXT("Look at Rotation: %f"), LookAtRotation.Yaw);
	}

	Destroy();

	
}


